<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.reflectionclass.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ja',
  ),
  'this' => 
  array (
    0 => 'reflectionclass.newlazyghost.php',
    1 => 'ReflectionClass::newLazyGhost',
  ),
  'up' => 
  array (
    0 => 'class.reflectionclass.php',
    1 => 'ReflectionClass',
  ),
  'prev' => 
  array (
    0 => 'reflectionclass.newinstancewithoutconstructor.php',
    1 => 'ReflectionClass::newInstanceWithoutConstructor',
  ),
  'next' => 
  array (
    0 => 'reflectionclass.newlazyproxy.php',
    1 => 'ReflectionClass::newLazyProxy',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ja',
    'path' => 'reference/reflection/reflectionclass/newlazyghost.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="reflectionclass.newlazyghost" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">ReflectionClass::newLazyGhost</h1>
  <p class="verinfo">(PHP 8 &gt;= 8.4.0)</p><p class="refpurpose"><span class="refname">ReflectionClass::newLazyGhost</span> &mdash; <span class="dc-title">新しいレイジーゴーストインスタンスを作成する</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-reflectionclass.newlazyghost-description">
  <h3 class="title">説明</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>ReflectionClass::newLazyGhost</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$initializer</code></span>, <span class="methodparam"><span class="type"><a href="language.types.integer.php" class="type int">int</a></span> <code class="parameter">$options</code><span class="initializer"> = 0</span></span>): <span class="type"><a href="language.types.object.php" class="type object">object</a></span></div>

  <p class="simpara">
   クラスの新しいレイジーゴーストインスタンスを作成し、
   <code class="parameter">initializer</code> をアタッチします。コンストラクタは呼び出されず、
   プロパティはデフォルト値に設定されません。オブジェクトの状態を
   初めて参照または変更する時に、
   <code class="parameter">initializer</code>をにより自動的に初期化されます。
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.initialization-triggers" class="link">初期化トリガー</a>および
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.initialization-sequence" class="link">初期化シーケンス</a>
   を参照してください。
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-reflectionclass.newlazyghost-parameters">
  <h3 class="title">パラメータ</h3>
  <dl>
   
    <dt><code class="parameter">initializer</code></dt>
    <dd>
     <span class="simpara">
      イニシャライザは以下のシグネチャを持つコールバックです:
     </span>
     <p class="para">
      <div class="methodsynopsis dc-description">
       <span class="methodname"><span class="replaceable">initializer</span></span>(<span class="methodparam"><span class="type"><a href="language.types.object.php" class="type object">object</a></span> <code class="parameter">$object</code></span>): <span class="type"><a href="language.types.void.php" class="type void">void</a></span></div>

      <dl>
       
        <dt><code class="parameter">object</code></dt>
        <dd>
         <span class="simpara">
          初期化される<code class="parameter">object</code>。この時点では、
          オブジェクトはもはやレイジーとしてマークされておらず、
          アクセスしても再び初期化がトリガーされることはありません。
         </span>
        </dd>
       
      </dl>
     </p>
     <span class="simpara">
      <code class="parameter">initializer</code>関数は <strong><code><a href="reserved.constants.php#constant.null">null</a></code></strong> を返すか、
      値を返さない必要があります。
     </span>
    </dd>
   
   
    <dt id="reflectionclass.newlazyghost.parameters.options"><code class="parameter">options</code></dt>
    <dd>
     <p class="para">
      <code class="parameter">options</code>には以下のフラグを組み合わせて
      指定できます:
      <dl>
       
        <dt>
         <strong><code><a href="class.reflectionclass.php#reflectionclass.constants.skip-initialization-on-serialize">ReflectionClass::SKIP_INITIALIZATION_ON_SERIALIZE</a></code></strong>
        </dt>
        <dd>
         <span class="simpara">
          デフォルトでは、レイジーオブジェクトのシリアライズは
          初期化がトリガーされます。このフラグを設定すると、
          初期化せずにシリアライズできるようになります。
         </span>
        </dd>
       
      </dl>
     </p>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-reflectionclass.newlazyghost-returnvalues">
  <h3 class="title">戻り値</h3>
  <p class="simpara">
   レイジーゴーストインスタンスを返します。オブジェクトにプロパティがない場合、または
   そのプロパティがすべてstaticまたはvirtualの場合、通常の（レイジーではない）インスタンスが
   返されます。
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.lifecycle" class="link">レイジーオブジェクトの
   ライフサイクル</a>も参照してください。
  </p>
 </div>


 <div class="refsect1 errors" id="refsect1-reflectionclass.newlazyghost-errors">
  <h3 class="title">エラー / 例外</h3>
  <p class="simpara">
   クラスが内部クラスであるか、<span class="classname"><a href="class.stdclass.php" class="classname">stdClass</a></span>を除く内部クラスを
   拡張している場合、<span class="classname"><a href="class.error.php" class="classname">Error</a></span>をスローします。
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-reflectionclass.newlazyghost-examples">
  <h3 class="title">例</h3>
  <div class="example" id="example-5363">
   <p><strong>例1 基本的な使用法</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br /></span><span style="color: #007700">class </span><span style="color: #0000BB">Example </span><span style="color: #007700">{<br />    public function </span><span style="color: #0000BB">__construct</span><span style="color: #007700">(public </span><span style="color: #0000BB">int $prop</span><span style="color: #007700">) {<br />        echo </span><span style="color: #0000BB">__METHOD__</span><span style="color: #007700">, </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br />    }<br />}<br /><br /></span><span style="color: #0000BB">$reflector </span><span style="color: #007700">= new </span><span style="color: #0000BB">ReflectionClass</span><span style="color: #007700">(</span><span style="color: #0000BB">Example</span><span style="color: #007700">::class);<br /></span><span style="color: #0000BB">$object </span><span style="color: #007700">= </span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">newLazyGhost</span><span style="color: #007700">(function (</span><span style="color: #0000BB">Example $object</span><span style="color: #007700">) {<br />     </span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">__construct</span><span style="color: #007700">(</span><span style="color: #0000BB">1</span><span style="color: #007700">);<br />});<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object </span><span style="color: #007700">instanceof </span><span style="color: #0000BB">Example</span><span style="color: #007700">);<br /><br /></span><span style="color: #FF8000">// 初期化をトリガーし、その後プロパティを取得します<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">prop</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>上の例の出力は以下となります。</p></div>
   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">lazy ghost object(Example)#3 (0) {
  [&quot;prop&quot;]=&gt;
  uninitialized(int)
}
bool(true)
Example::__construct
int(1)</pre>
</div>
   </div>
  </div>
 </div>


 <div class="refsect1 seealso" id="refsect1-reflectionclass.newlazyghost-seealso">
  <h3 class="title">参考</h3>
  <ul class="simplelist">
   <li><a href="language.oop5.lazy-objects.php" class="link">レイジーオブジェクト</a></li>
   <li><span class="methodname"><a href="reflectionclass.newlazyproxy.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::newLazyProxy()</a> - 新しいレイジープロキシインスタンスを作成する</span></li>
   <li><span class="methodname"><a href="reflectionclass.newinstancewithoutconstructor.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::newInstanceWithoutConstructor()</a> - コンストラクタを起動せずに新しいクラスのインスタンスを作成する</span></li>
   <li><span class="methodname"><a href="reflectionclass.resetaslazyghost.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::resetAsLazyGhost()</a> - オブジェクトをリセットしてレイジーとしてマークする</span></li>
   <li><span class="methodname"><a href="reflectionclass.marklazyobjectasinitialized.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::markLazyObjectAsInitialized()</a> - イニシャライザまたはファクトリを呼び出さずレイジーオブジェクトを初期化済みとしてマークする</span></li>
   <li><span class="methodname"><a href="reflectionclass.initializelazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::initializeLazyObject()</a> - レイジーオブジェクトを強制的に初期化する</span></li>
   <li><span class="methodname"><a href="reflectionclass.isuninitializedlazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::isUninitializedLazyObject()</a> - オブジェクトがレイジーで未初期化かどうかを調べる</span></li>
   <li><span class="methodname"><a href="reflectionproperty.setrawvaluewithoutlazyinitialization.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::setRawValueWithoutLazyInitialization()</a> - 遅延初期化をトリガーせず生のプロパティ値を設定する</span></li>
   <li><span class="methodname"><a href="reflectionproperty.skiplazyinitialization.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::skipLazyInitialization()</a> - プロパティを非レイジーとしてマークする</span></li>
   <li><span class="methodname"><a href="reflectionproperty.islazy.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::isLazy()</a> - プロパティがレイジーであるかどうかを調べる</span></li>
  </ul>
 </div>


</div><?php manual_footer($setup); ?>